Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jdbc.core
Interface PreparedStatementCallback<T>

All Known Implementing Classes:
  AbstractLobCreatingPreparedStatementCallback

    public interface PreparedStatementCallback<T>

Generic callback interface for code that operates on a PreparedStatement. Allows to execute any number of operations on a single PreparedStatement, for example a single `executeUpdate` call or repeated `executeUpdate` calls with varying parameters.

Used internally by JdbcTemplate, but also useful for application code. Note that the passed-in PreparedStatement can have been created by the framework or by a custom PreparedStatementCreator. However, the latter is hardly ever necessary, as most custom callback actions will perform updates in which case a standard PreparedStatement is fine. Custom actions will always set parameter values themselves, so that PreparedStatementCreator capability is not needed either.

Since:
  16.03.2004
Author:
  Juergen Hoeller
See Also:
  `JdbcTemplate.execute(String, PreparedStatementCallback)`, `JdbcTemplate.execute(PreparedStatementCreator, PreparedStatementCallback)`

Method Summary
`T` | `doInPreparedStatement(java.sql.PreparedStatement ps)` Gets called by `JdbcTemplate.execute` with an active JDBC PreparedStatement.

Method Detail

### doInPreparedStatement

    T doInPreparedStatement(java.sql.PreparedStatement ps)
                            throws java.sql.SQLException,
                                   DataAccessException

  Gets called by `JdbcTemplate.execute` with an active JDBC PreparedStatement. Does not need to care about closing the Statement or the Connection, or about handling transactions: this will all be handled by Spring's JdbcTemplate.

  NOTE: Any ResultSets opened should be closed in finally blocks within the callback implementation. Spring will close the Statement object after the callback returned, but this does not necessarily imply that the ResultSet resources will be closed: the Statement objects might get pooled by the connection pool, with `close` calls only returning the object to the pool but not physically closing the resources.

  If called without a thread-bound JDBC transaction (initiated by DataSourceTransactionManager), the code will simply get executed on the JDBC connection with its transactional semantics. If JdbcTemplate is configured to use a JTA-aware DataSource, the JDBC connection and thus the callback code will be transactional if a JTA transaction is active.

  Allows for returning a result object created within the callback, i.e. a domain object or a collection of domain objects. Note that there's special support for single step actions: see JdbcTemplate.queryForObject etc. A thrown RuntimeException is treated as application exception, it gets propagated to the caller of the template.

  Parameters:
    `ps` - active JDBC PreparedStatement
  Returns:
    a result object, or `null` if none
  Throws:
    `java.sql.SQLException` - if thrown by a JDBC method, to be auto-converted to a DataAccessException by a SQLExceptionTranslator
    `DataAccessException` - in case of custom exceptions
  See Also:
    `JdbcTemplate.queryForObject(String, Object[], Class)`, `JdbcTemplate.queryForList(String, Object[])`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD